{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Past CO Reports
{% endblock %}

{% block rightPane %}
    {% if perms.curriculum.can_view_my_timetable %}
        <div class="row" xmlns="http://www.w3.org/1999/html">
            <div class="x_panel">
                <div class="x_title">
                    <h2>
                        <i class="icomoon icon-calendar"></i> Past CO Reports
                    </h2>
                    <div class="clearfix"></div>
                </div>
                <div class="row">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <form id="submit_form" class="form-horizontal form-label-left" method="POST">{% csrf_token %}

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Department
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="department" id="department" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                        {% for each in departmentList %}
                                            <option value="{{ each.pk }}">{{ each.acronym }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Batch
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="batch" id="batch" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Semester
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="semester" id="semester" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Course
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="course" id="course" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Unit Test
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="unitTest" id="unitTest" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>


                            <br>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <button type="submit" class="btn1 btn-blue-grey1">Fetch CO report
                                    </button>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>

                {% if dictionary.avail == 'true' %}
                    <div class="x_panel">
                        <div class="col-md-offset-8">
                            <button type="button" class="btn btn-primary" id='getGraph'>
                                View Graph
                            </button>
                            <button type="button" class="btn btn-primary" id='getPdf'>
                                Generate PDF
                            </button>
                        </div>
                        <div class="x_content">
                            <form>
                                <div class="table-responsive">
                                    <table id="table" class="table table-striped table-condensed table-hover">
                                        <thead>
                                        <tr id="headsection">
                                            <th rowspan="3">S.No.</th>
                                            <th rowspan="3">Reg No.</th>
                                            <th rowspan="3">Student Name</th>
                                            {% for co in dictionary.coPatternList %}
                                                <th>Q.{{ co.userPrespectiveQuestionNumber }}</th>
                                            {% endfor %}
                                        </tr>
                                        <tr id="cosection">
                                            {% for co in dictionary.coPatternList %}
                                                <th>{{ co.coMapped }}</th>
                                            {% endfor %}
                                            <th>Total</th>
                                        </tr>
                                        <tr id="marksection">
                                            {% for co in dictionary.coPatternList %}
                                                <th>{{ co.maximumMark }}</th>
                                            {% endfor %}
                                            <th>Marks</th>
                                        </tr>
                                        </thead>
                                        <tbody id="bodysection">
                                        {% for student in dictionary.coMarkList %}
                                            {% if student.markEqualsCo == 'true' %}
                                                <tr>
                                                    {% elif student.markEqualsCo == 'false' %}
                                                <tr style="background-color: rgba(255,22,66,0.65)">
                                                    {% else %}
                                                <tr style="background-color: rgba(255,192,93,0.37)">
                                            {% endif %}
                                        <td>{{ forloop.counter }}</td>
                                        <td>{{ student.studentName }}</td>
                                        <td>{{ student.registerNumber }}</td>
                                        {% if student.coList %}
                                            {% for mark in student.coList %}
                                                <td>{{ mark }}</td>
                                            {% endfor %}
                                        {% else %}
                                            <td colspan="{{ dictionary.totalQuestions }}"></td>
                                        {% endif %}
                                        <td>{{ student.totalMarks }}</td>

                                        </tr>
                                        {% endfor %}
                                        </tbody>
                                    </table>
                                </div>
                            </form>
                        </div>
                    </div>
                {% elif dictionary.avail == 'false' %}
                    <div id="alertfield" class="x_content">
                        <div class="alert alert-warning" role="alert" align="center">
                            <h4 style="font-size: 18px"> CO Pattern is not set for unit test
                                <strong>{{ unitTestNumber }}</strong>
                                of the course <strong>{{ staffCourseInstance.course }}</strong>
                            </h4>
                        </div>
                    </div>
                {% endif %}

            </div>
        </div>
    {% endif %}

    <form id="dummyForm" method="POST">
        {% csrf_token %}
    </form>

    <script type="text/javascript">

        {% if staffCourseInstance %}
            $('#getPdf').click(function () {
                window.open('{% url 'pdfCoMarks' staffCoursePk=staffCourseInstance.pk unitTestNumber=unitTestNumber %}', '_self');
            });

            $('#getGraph').click(function () {
                window.open('{% url 'viewGraph' staffCoursePk=staffCourseInstance.pk unitTestNumber=unitTestNumber %}', '_self');
            });
        {% endif %}

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("change", '#department', function (e) {
            $('#batch').empty();
            $('#batch').append('<option disabled selected>' + '-----------' + '</option>');
            {% for each in batchList %}
                $('#batch').append('<option value="{{ each.id }}">{{ each }}</option>');
            {% endfor %}
        });

        $(document).on("change", '#batch', function (e) {
            var departmentPk = $('#department').val();
            var batchPk = $('#batch').val();

            $.ajax({
                type: "POST",
                data: {
                    departmentPk: departmentPk,
                    batchPk: batchPk,
                    action: 'getSemesterPlan',
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'pastCoMarksReport' %}',
                success: function (data) {
                    if (data.semesterList.length == 0) {
                        alert('No Semester Plan');
                    }

                    $('#semester').empty();
                    $('#semester').append('<option disabled selected>' + '-----------' + '</option>');
                    var i;
                    var temp;
                    for (i = 0; (temp = data.semesterList[i]); i++) {
                        $('#semester').append('<option value="' + temp['pk'] + '">' + temp['displayText'] + '</option>');
                    }
                    $('#course').empty();
                    $('#course').append('<option disabled selected>' + '-----------' + '</option>');
                    $('#unitTest').empty();
                    $('#unitTest').append('<option disabled selected>' + '-----------' + '</option>');
                }
            });
        });


        $(document).on("change", '#semester', function (e) {
            var semesterPk = $(this).val();

            $.ajax({
                type: "POST",
                data: {
                    semesterPk: semesterPk,
                    action: 'getCourses',
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'pastCoMarksReport' %}',
                success: function (data) {
                    if (data.courseList.length == 0) {
                        alert('No Courses');
                    }

                    $('#course').empty();
                    $('#course').append('<option disabled selected>' + '-----------' + '</option>');
                    var i;
                    var temp;
                    for (i = 0; (temp = data.courseList[i]); i++) {
                        $('#course').append('<option value="' + temp['pk'] + '">' + temp['course'] + '</option>');
                    }
                    $('#unitTest').empty();
                    $('#unitTest').append('<option disabled selected>' + '-----------' + '</option>');
                }
            });

        });

        $(document).on("change", '#course', function (e) {
            $('#unitTest').empty();
            $('#unitTest').append('<option disabled selected>' + '-----------' + '</option>');
            $('#unitTest').append('<option value="1">Unit Test I</option>');
            $('#unitTest').append('<option value="2">Unit Test II</option>');
            $('#unitTest').append('<option value="3">Unit Test III</option>');
        });

        $(document).on("submit", '#submit_form', function (e) {

            e.preventDefault();

            var department = $('#department').val();
            var batch = $('#batch').val();
            var semester = $('#semester').val();
            var course = $('#course').val();
            var unitTest = $('#unitTest').val();

            if (department == null) {
                alert('Select Department!');
                return;
            }

            if (batch == null) {
                alert('Select Batch!');
                return;
            }

            if (semester == null) {
                alert('Select Semester!');
                return;
            }

            if (course == null) {
                alert('Select Course!');
                return;
            }

            if (unitTest == null) {
                alert('Select Unit Test Number!');
                return;
            }

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: $('#course').val(),
                name: 'staffCoursePkOnCoRequest'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: $('#unitTest').val(),
                name: 'unitTestNumberOnCoRequest'
            });
            $hiddenInput.appendTo('#dummyForm');

            $('#dummyForm').submit();

        });

    </script>

{% endblock %}